import * as mc from "@minecraft/server"
import { ActionFormData, ModalFormData } from "@minecraft/server-ui"
function vecdt(vetor1, vetor2) {

    const chaves1 = Object.keys(vetor1);
    const chaves2 = Object.keys(vetor2);

    if (chaves1.length !== chaves2.length || !chaves1.every(chave => chaves2.includes(chave))) {
        throw new Error("Os vetores devem ter as mesmas propriedades.");
    }


    const somaQuadrados = chaves1.reduce((soma, chave) => {
        const diferenca = vetor1[chave] - vetor2[chave];
        return soma + diferenca ** 2;
    }, 0);


    return Math.sqrt(somaQuadrados);
}
function verString(texto) {

    const regex = /^[a-zA-Z0-9 ]+$/;
    return regex.test(texto);
}

function pegarN(input) {

    const partes = input.split(" -> ")[1].replace("§9", "").split(" - ");
    if (partes.length > 1) {

        const segundaParte = partes[1].split(" §8- ")[0];
        return segundaParte.trim();
        console.warn(segundaParte.trim())
    }
    return null;

}
function verificarLimiteSlp(itemStack, player) {
    let resultslp;
    if (!mc.world.getDynamicProperty("slp_limit")) {
        mc.world.setDynamicProperty("slp_limit", 6)
    }

    if (itemStack.typeId == "blayy:slp_creator") {
        if (player.getDynamicProperty("slp_creator") <= mc.world.getDynamicProperty("slp_limit")) {
            resultslp = true
        } else {
            resultslp = false
        }
    }
    if (itemStack.typeId == "blayy:slp_creator_2") {
        if (player.getDynamicProperty("slp_creator_2") <= mc.world.getDynamicProperty("slp_limit")) {
            resultslp = true
        } else {
            resultslp = false
        }
    }
    return resultslp;
}

mc.world.beforeEvents.itemUseOn.subscribe(({ source: player, itemStack, block }) => {

    let hasBlock = false
    let loc = { x: block.location.x, y: block.location.y + 1, z: block.location.z }


    let ent = player.dimension
        .getEntities({
            type: "blayy:slp_ent",
        }).forEach(ent => {
            let entloc = { x: ent.location.x, y: ent.location.y + 1, z: ent.location.z }
            if (vecdt(loc, entloc) <= 40 && hasBlock == false) {
                hasBlock = true

            }
        })
   
    if (itemStack.typeId.includes("blayy:slp_creator")) {
        if (!player.getDynamicProperty("slp_creator") && !player.getDynamicProperty("slp_creator_2")) {
            player.setDynamicProperty("slp_creator", 0)
            player.setDynamicProperty("slp_creator_2", 0)
        }
        if (hasBlock == true) {
            player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.distance.error"}]}`)
        } else {
            if (!itemStack.getLore()[0]) {
                if (verificarLimiteSlp(itemStack, player)) {


                    mc.system.run(() => {

                        let createForm = new ModalFormData()
                        if (itemStack.typeId == "blayy:slp_creator") {
                            createForm.title({ translate: "item.blayy:slp_creator" })
                            
                        }
                        if (itemStack.typeId == "blayy:slp_creator_2") {
                            createForm.title({ translate: "item.blayy:slp_creator_2" })
                         
                        }
                        createForm.textField({ translate: "slp.input.name" }, { translate: "text.type.here" });

                        createForm.dropdown("Select a color", ["§fO", "§cO", "§eO", "§6O", "§5O", "§bO"]);
                        let colorarr = ["§f", "§c", "§e", "§6", "§5", "§b"];
                        createForm.show(player).then(r => {
                            if (r.canceled) return;
                            player.runCommandAsync(`clear @s ${itemStack.typeId} 0 1`)
                            let name1 = `${Array(10).fill().map(() => String.fromCharCode(Math.floor(Math.random() * 26) + 97)).join('')}`;
                            player.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} blayy:slp_block`)
                            if (itemStack.typeId == "blayy:slp_creator") {
                                player.setDynamicProperty("slp_creator", player.getDynamicProperty("slp_creator") + 1)
                                player.runCommandAsync(`summon blayy:slp_ent "§bTier 1 -> ${colorarr[r.formValues[1]]}${r.formValues[0].replace("-", "_")} §9- ${player.nameTag} §8- ${name1}" ${loc.x} ${loc.y} ${loc.z}`)
                                mc.system.runTimeout(() => { player.runCommandAsync(`fill ${loc.x + 7} ${loc.y + 7} ${loc.z + 7} ${loc.x - 8} ${loc.y - 8} ${loc.z - 8} blayy:fundo_block [] outline`) }, 20)
                            }
                            if (itemStack.typeId == "blayy:slp_creator_2") {
                                player.setDynamicProperty("slp_creator_2", player.getDynamicProperty("slp_creator_2") + 1)
                                player.runCommandAsync(`summon blayy:slp_ent "§uTier 2 -> ${colorarr[r.formValues[1]]}${r.formValues[0]} §9- ${player.nameTag} §8- ${name1}" ${loc.x} ${loc.y} ${loc.z}`)
                                mc.system.runTimeout(() => { player.runCommandAsync(`fill ${loc.x + 14} ${loc.y + 14} ${loc.z + 14} ${loc.x - 15} ${loc.y - 15} ${loc.z - 15} blayy:fundo_block_2 [] outline`) }, 20)
                            }
                        })
                    })
                }else {
                  
                    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.limit.error"}, {"text":" ${mc.world.getDynamicProperty("slp_limit")} "}, {"translate":"slp.limit.error2"}, {"text":" ${mc.world.getDynamicProperty("slp_limit") * 2} "}, {"translate":"slp.limit.error3"}]}`)
                }
            }
            else {

                player.runCommandAsync(`clear @s ${itemStack.typeId} 0 1`)
                if (itemStack.typeId == "blayy:slp_creator") {

                    player.runCommandAsync(`structure load ${itemStack.getLore()[0]} ${loc.x - 8} ${loc.y - 8} ${loc.z - 8}`)
                }
                if (itemStack.typeId == "blayy:slp_creator_2") {
                    player.runCommandAsync(`structure load ${itemStack.getLore()[0]} ${loc.x - 15} ${loc.y - 15} ${loc.z - 15}`)
                }
                mc.system.runTimeout(() => { player.runCommandAsync(`structure delete ${itemStack.getLore()[0]}`) }, 20)
                player.runCommandAsync(`setblock ${loc.x} ${loc.y} ${loc.z} blayy:slp_block`)

            }
        }
    }

})

mc.world.beforeEvents.playerBreakBlock.subscribe(({ player, block }) => {
    if (block.getItemStack().typeId == "blayy:slp_block" && player.dimension.getEntitiesAtBlockLocation(block.location)[0].typeId == "blayy:slp_ent") {
        let name = player.dimension.getEntitiesAtBlockLocation(block.location)[0].nameTag.split(" §8- ")[1];
        console.warn(name)
        mc.system.run(() => {


            let ent = player.dimension.getEntitiesAtBlockLocation(block.location)[0]

            if (ent.nameTag.split(" -> ")[0] == "§bTier 1") {
                let stack = new mc.ItemStack("blayy:slp_creator", 1)
                stack.setLore([`${name}`])

                player.runCommandAsync(`structure save ${name} ${block.location.x + 7} ${block.location.y + 7} ${block.location.z + 7} ${block.location.x - 8} ${block.location.y - 8} ${block.location.z - 8} true`)

                player.dimension.spawnItem(stack, player.location)

                player.runCommandAsync(`fill ${block.location.x + 7} ${block.location.y + 7} ${block.location.z + 7} ${block.location.x - 8} ${block.location.y - 8} ${block.location.z - 8} air []`)

                ent.runCommandAsync(`execute as @e[r=7] run scriptevent blayy:remove_entities`)
                if (ent) return ent.runCommandAsync(`kill @s`)
            }
            if (ent.nameTag.split(" -> ")[0] == "§uTier 2") {
                let stack = new mc.ItemStack("blayy:slp_creator_2", 1)
                stack.setLore([`${name}`])
                player.runCommandAsync("effect @s slow_falling 10 1")
                player.runCommandAsync(`structure save ${name} ${block.location.x + 14} ${block.location.y + 14} ${block.location.z + 14} ${block.location.x - 15} ${block.location.y - 15} ${block.location.z - 15} true`)

                player.dimension.spawnItem(stack, player.location)
                player.runCommandAsync(`setblock  ${block.location.x} ${block.location.y} ${block.location.z} air`)
                player.runCommandAsync(`fill ${block.location.x + 14} ${block.location.y + 14} ${block.location.z + 14} ${block.location.x - 15} ${block.location.y - 15} ${block.location.z - 15} air []`)

                ent.runCommandAsync(`execute as @e[r=14] run scriptevent blayy:remove_entities`)
                if (ent) return ent.runCommandAsync(`kill @s`)
            }



        })
    }

})
mc.world.beforeEvents.worldInitialize.subscribe((ev) => {

    ev.blockComponentRegistry.registerCustomComponent("blayy:slp_block_click", {
        onPlayerInteract({ block, player }) {

            let ent = player.dimension.getEntitiesAtBlockLocation(block.location)[0]
            if (ent?.typeId == "blayy:slp_ent") {
                let gform = new ActionFormData()
                let acessarr = []
                ent.getTags().forEach(tag => {
                    if (tag.startsWith("blayy:slp_acess_")) {
                        acessarr.push(tag)
                    }
                })
                gform.title({ translate: "tile.blayy:slp_block.name" })
                const novaArr = acessarr.map(item => item.replace("blayy:slp_acess_", "").trim());
                gform.body({
                    rawtext: [
                        { "translate": `Players with acess:` },
                        { "text": `\n§a${novaArr}` }
                    ]
                })
                gform.button({
                    rawtext: [
                        { "translate": `slp.addacess` }
                    ]
                }, "textures/ui/Add-Ons_Nav_Icon36x36")

                gform.show(player).then(r => {

                    if (r.selection == 0) {

                        let playersarr = mc.world.getPlayers()
                        let pform = new ActionFormData()
                        pform.title({ translate: "tile.blayy:slp_block.name" })
                        let parr = []
                        playersarr.forEach(pl => {
                            if (pl.nameTag != player.nameTag) {
                                pform.button({
                                    rawtext: [
                                        { "text": `< ` },
                                        { "translate": `${pl.nameTag}` },
                                        { "text": ` >` }
                                    ]
                                })
                                parr.push(pl.nameTag)
                            }
                        })
                        if (!parr[0]) {
                            pform.button({
                                rawtext: [
                                    { "translate": `text.nf1` }
                                ]
                            }, `textures/ui/close_button_default_light`)
                        }
                        pform.show(player).then(r => {
                            parr.forEach(pl => {
                                if (r.selection == parr.indexOf(pl)) {
                                    mc.system.run(() => {
                                        ent.addTag(`blayy:slp_acess_${pl}`)
                                    })
                                    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.ad.acess"},{"text":" ${pl}"}]}`)
                                }
                            })
                        })
                    }

                })
            }
        }
    })
})
/*
mc.world.afterEvents.itemUse.subscribe(({ itemStack: item, source: player }) => {
    if (item.typeId === "blayy:slp_teleporter") {

        if (item.getLore()[0]) {
            player.runCommandAsync(`tp ${player.nameTag} ${item.getLore()[0]}`)
            item.setLore([])
        } else {

            player.dimension
                .getEntities({
                    type: "blayy:slp_ent",
                }).forEach(ent => {
                    console.warn(ent.typeId)
                    let acessarr = []
                    ent.getTags().forEach(tag => {
                        if (tag.startsWith("blayy:slp_acess_")) {
                            acessarr.push(tag)
                        }
                    })
                    if (pegarN(ent.nameTag) === player.nameTag) {
                        mc.system.run(() => {
                            item.setLore([`${Math.trunc(player.location.x, player.location.y, player.location.z)}`])
                        })

                        player.runCommandAsync(`tp @s ${ent.location.x} ${ent.location.y} ${ent.location.z}`)
                    } else if (acessarr.includes(`blayy:slp_acess_${player.nameTag}`)) {
                        //  item.setLore([Math.trunc(player.location.x, player.location.y, player.location.z)])
                        ent.teleport(ent.location)
                    }

                })

        }
    }
})*/
mc.system.runInterval(async fds => {
    mc.world.getPlayers().forEach(player => {
        let loc = { x: player.location.x, y: player.location.y, z: player.location.z }
       
        player.dimension
            .getEntities({
                type: "blayy:slp_ent",
            }).forEach(ent => {
                let entloc = { x: ent.location.x, y: ent.location.y, z: ent.location.z }
                if (vecdt(loc, entloc) <= 11 && ent.nameTag.split(" -> ")[0] == "§bTier 1") {
                    if (pegarN(ent.nameTag) != player.nameTag && !ent.getTags().includes(`blayy:slp_acess_${player.nameTag}`)) {
                        player.runCommandAsync(`effect @s slow_falling 10 1`)
                        player.runCommandAsync(`tp @s ~~10~`)
                    }
                }
                else if (vecdt(loc, entloc) <= 20 && ent.nameTag.split(" -> ")[0] == "§uTier 2") {
                    if (pegarN(ent.nameTag) != player.nameTag && !ent.getTags().includes(`blayy:slp_acess_${player.nameTag}`)) {
                        player.runCommandAsync(`effect @s slow_falling 10 1`)
                        player.runCommandAsync(`tp @s ~~18~`)
                    }

                }
                if (vecdt(loc, entloc) <= 24) {
                    if (pegarN(ent.nameTag) === player.nameTag || ent.getTags().includes(`blayy:slp_acess_${player.nameTag}`)) {
                        let bd = player.getBlockFromViewDirection({ maxDistance: 2 })
                        let bloco = bd?.block

                        if (bloco?.typeId == "blayy:fundo_block" || bloco?.typeId == "blayy:fundo_block_2") {
                            if (bd?.face != "Up" && bd.face != "Down") return player.teleport({ x: player.location.x + player.getViewDirection().x, y: player.location.y + 2, z: player.location.z + player.getViewDirection().z })


                        }
                    }
                }


            })

    })

}, 10)
mc.system.afterEvents.scriptEventReceive.subscribe(({ id, sourceEntity: entity }) => {
    if (id == "blayy:slp_ent") {

    }
    if (id == "blayy:remove_entities") {
        entity.remove()
    }
    if (id.startsWith("blayy:editslp_")) {
        console.warn(mc.world.getDynamicProperty("slp_limit"))

        let valor = id.replace("blayy:editslp_", "");
    
        if (!isNaN(valor)) {
            valor = Number(valor);
            mc.world.setDynamicProperty("slp_limit", valor);
            entity.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.command.value.success"}]}`)
        } else {
            entity.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.command.value.error"}]}`)
        }
    }

})

mc.world.afterEvents.itemUse.subscribe(({ itemStack: item, source: player }) => {
    if (item.typeId === "blayy:slp_teleporter") {
        let entarr = []
        mc.world.getDimension("overworld").getEntities({
            type: "blayy:slp_ent",
        }).forEach(ent => {
            entarr.push(`${ent.nameTag}`)

        })

        let entform = new ActionFormData()
        entform.title({ translate: "item.blayy:slp_teleporter" })
        entform.body({
            rawtext: [
                { "translate": `text.slp_bases.tp` }
            ]
        })
        entarr.forEach(entbutton => {
            entform.button({
                rawtext: [

                    { "translate": `${entbutton}` }

                ]
            })
        })
        if (!entarr[0]) {
            entform.button({
                rawtext: [
                    { "translate": `text.nf2` }
                ]
            }, `textures/ui/close_button_default_light`)
        }
        entform.show(player).then(r => {
            entarr.forEach(entbutton => {
                if (r.selection == entarr.indexOf(entbutton)) {
                    let ent_acess = player.dimension.getEntities({
                        name: entbutton
                    })
                    if (pegarN(ent_acess[0].nameTag) === player.nameTag || ent_acess[0].getTags().includes(`blayy:slp_acess_${player.nameTag}`)) {
                        let loc = ent_acess[0].location
                        player.teleport(loc)


                    } else {
                        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"slp.f.acess"}]}`)
                    }
                }
            })
        })
    }

})